import { o as y } from "./index.104c9c16.mjs";
import { computed as r, resolveComponent as k, openBlock as l, createElementBlock as s, normalizeClass as V, createElementVNode as v, withKeys as w, withModifiers as x, renderSlot as d, createTextVNode as p, toDisplayString as c, withDirectives as u, vModelText as _, Fragment as g, renderList as O, createCommentVNode as b, createBlock as m, createVNode as S, Transition as C, withCtx as B, vShow as N } from "vue";
import { p as z } from "./propSizeMixin.e38322d6.mjs";
import { _ as T } from "./_plugin-vue_export-helper.e9cbb45e.mjs";
import "./index.673e51a0.mjs";
const j = {
  provide() {
    return {
      value: r(() => this.value),
      multiple: r(() => this.multiple),
      searchable: r(() => this.searchable),
      searchValue: r(() => this.search),
      visibleOptions: r(() => this.visibleOptions)
    };
  },
  mixins: [z()],
  props: {
    value: {
      type: [Object, Array],
      default: null
    },
    multiple: {
      type: Boolean,
      default: !1
    },
    placeholder: {
      type: String,
      default: "Choose an option"
    },
    searchable: {
      type: Boolean,
      default: !1
    },
    clearable: {
      type: Boolean,
      default: !0
    },
    loading: {
      type: Boolean,
      default: !1
    },
    disabled: {
      type: Boolean,
      default: !1
    }
  },
  data() {
    return {
      dropdownVisible: !1,
      focusedOptionIndex: null,
      search: null,
      visibleOptions: null
    };
  },
  computed: {
    hasValue() {
      return !!(this.multiple && this.value.length > 0 || !this.multiple && this.value);
    },
    classObject() {
      return {
        [`lv-select--size-${this.size}`]: !0,
        "lv-select--disabled": !!this.disabled || !!this.loading,
        "lv-select--loading": !!this.loading
      };
    }
  },
  watch: {
    search(o) {
      !this.dropdownVisible && o && (this.dropdownVisible = !0);
    },
    value(o) {
      !this.multiple && this.dropdownVisible && (this.dropdownVisible = !1), o && this.search && (this.search = null);
    }
  },
  mounted() {
    this.visibleOptions = this.getVisibleOptions(), y(this.$refs.select, () => {
      this.dropdownVisible = !1;
    });
  },
  updated() {
    this.$nextTick(() => {
      this.visibleOptions = this.getVisibleOptions();
    });
  },
  methods: {
    getVisibleOptions() {
      return this.$el.querySelectorAll(".lv-select-option").length;
    },
    onClickSelection() {
      this.dropdownVisible = !this.dropdownVisible;
    }
  }
}, L = ["aria-expanded"], M = {
  key: 0,
  class: "lv-select__value"
}, A = ["placeholder"], D = {
  key: 2,
  class: "lv-select__placeholder"
}, E = {
  key: 1,
  class: "lv-select__value"
}, K = ["placeholder"], U = {
  key: 2,
  class: "lv-select__placeholder"
}, q = {
  class: "lv-select__dropdown",
  role: "listbox"
}, F = {
  key: 0,
  class: "lv-select__no-options"
};
function I(o, i, e, G, a, n) {
  const h = k("lv-icon");
  return l(), s("div", {
    ref: "select",
    class: V(["lv-select", n.classObject]),
    role: "combobox",
    "aria-expanded": a.dropdownVisible,
    "aria-haspopup": "listbox"
  }, [
    v("div", {
      ref: "combobox",
      class: "lv-select__input",
      tabindex: "0",
      onClick: i[2] || (i[2] = (...t) => n.onClickSelection && n.onClickSelection(...t)),
      onKeydown: i[3] || (i[3] = w(x((...t) => n.onClickSelection && n.onClickSelection(...t), ["prevent"]), ["enter", "space"]))
    }, [
      e.multiple ? e.multiple ? (l(), s("div", E, [
        n.hasValue ? (l(!0), s(g, { key: 0 }, O(e.value, (t, f) => (l(), s("span", {
          key: f,
          class: "lv-select__value-item"
        }, [
          d(o.$slots, "value", {
            values: e.value,
            value: t
          }, () => [
            p(c(t.label), 1)
          ])
        ]))), 128)) : e.searchable ? u((l(), s("input", {
          key: 1,
          "onUpdate:modelValue": i[1] || (i[1] = (t) => a.search = t),
          class: "lv-select__search",
          type: "text",
          placeholder: e.placeholder
        }, null, 8, K)), [
          [_, a.search]
        ]) : (l(), s("div", U, c(e.placeholder), 1))
      ])) : b("", !0) : (l(), s("div", M, [
        n.hasValue ? d(o.$slots, "value", {
          key: 0,
          value: e.value
        }, () => [
          p(c(e.value.label), 1)
        ]) : e.searchable ? u((l(), s("input", {
          key: 1,
          "onUpdate:modelValue": i[0] || (i[0] = (t) => a.search = t),
          class: "lv-select__search",
          type: "text",
          placeholder: e.placeholder
        }, null, 8, A)), [
          [_, a.search]
        ]) : (l(), s("div", D, c(e.placeholder), 1))
      ])),
      e.loading ? (l(), m(h, {
        key: 2,
        class: "lv-select__loading",
        name: "loader-2"
      })) : (l(), m(h, {
        key: 3,
        class: "lv-select__icon",
        name: "chevron-down"
      }))
    ], 544),
    S(C, { name: "dropdown" }, {
      default: B(() => [
        u(v("div", q, [
          d(o.$slots, "default"),
          a.visibleOptions ? b("", !0) : (l(), s("div", F, "No options found"))
        ], 512), [
          [N, a.dropdownVisible]
        ])
      ]),
      _: 3
    })
  ], 10, L);
}
const W = /* @__PURE__ */ T(j, [["render", I]]);
export {
  W as default
};
